declare type ClientRoute = {
    name?: string;
    path: string;
    load: () => any;
    children?: ClientRoute[];
};
declare type ClientRoutes = ClientRoute[];
declare type RenderContext = {
    url: string;
    routes: ClientRoutes;
    initialState: Record<string, any>;
};
declare type RenderResult = undefined | null | {
    html?: string;
    head?: string;
    htmlAttrs?: string;
    bodyAttrs?: string;
};
declare type Render = (renderContext: RenderContext) => RenderResult | Promise<RenderResult>;

export { ClientRoute, ClientRoutes, Render, RenderContext, RenderResult };
