'use strict';

var server = require('./server.js');
require('fs');
require('path');
require('sirv');
require('serialize-javascript');
require('querystring');
require('@egoist/router');
require('debug');

const getRequestHandler = async (api) => {
  const viteServer = api.viteServer;
  return async (req, res) => {
    const {handler} = await server.createHandler({
      cwd: api.rootDir,
      dev: true,
      devMiddleware: viteServer.middlewares,
      viteServer,
      fixStacktrace: (err) => viteServer.ssrFixStacktrace(err)
    });
    return handler(req, res);
  };
};

exports.getRequestHandler = getRequestHandler;
