import { createHandler } from './server.mjs';
import 'fs';
import 'path';
import 'sirv';
import 'serialize-javascript';
import 'querystring';
import '@egoist/router';
import 'debug';

const getRequestHandler = async (api) => {
  const viteServer = api.viteServer;
  return async (req, res) => {
    const {handler} = await createHandler({
      cwd: api.rootDir,
      dev: true,
      devMiddleware: viteServer.middlewares,
      viteServer,
      fixStacktrace: (err) => viteServer.ssrFixStacktrace(err)
    });
    return handler(req, res);
  };
};

export { getRequestHandler };
